package com.eactive.eai.batch.job.jobItem.ssnet;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_SSNBT_0620 extends DefaultTelegram implements TelegramService
{

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    /**
     * 생성자
     */
    public SEND_SSNBT_0620() {
        //결번확인요구
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;
            
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_RECEIVE) ) {
                result = saveToFile();
            }
            if (!result) return false;
            
            //전송길이 - 아데나 장비와 TCP통신을 위한 전문길이 필드
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TRANSACTION CODE
            //- 신/구 고객을 구분하기 위한 코드
            //- 기존고객코드 : EG01, EG05(구버젼 IBM tr id)
            //- EG01,EG05를 제외하고는 모두 신규고객(Space처리)
            //compileField(1, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[1]);
            compileField(1, "", this.al_FieldProps[1]);

            //전문종별코드. 전문기능을 나타내는 코드 ('0600'/'0610')
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 : 전문의 처리결과를 나타내는 코드로 REQUEST전문에는 '0' 을 SET 하며
            //RESPONSE 전문에는 해당내용을 SET 한다.
            //'000' = 정상 '310' = 송신자 계정오류 '001' = 송신집계오류
            //'320' = 송신자 ID 오류 '330' = 송신자 PSWD오류 '010' = NUMERIC오류
            //'340' = 수신자계정오류 '350' = 수산자 ID오류 '999' = 기타오류
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //고객코드 - 현재 space 처리
            compileField(4, "", this.al_FieldProps[4]);

            //최종일련번호 - 결번전문 확인요구 및 완료시 SET 함
            compileField(5, "" + batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[5]);

            //전문내용구분코드 - 'C' : 결번전문확인 요구 전문
            //                'E' : 결번 확인 완료(결번이 없을때)
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ) {
                compileField(6, TelegramKeys.SSNET_MISS_REQ, this.al_FieldProps[6]);
            }else{
                compileField(6, TelegramKeys.SSNET_MISS_RES, this.al_FieldProps[6]);
            }

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += getCalculatedLength(this.al_Field.size()-1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }
    
    private boolean saveToFile() {

    	// 기 처리 완료된 시퀀스를 저장하여야 하는데 삼성네트웍스 프로토콜에서는 block 넘버가 의미 없으므로 이를 사용하도록 한다.
    	int lastSeq = batchDoc.getBatchMsg().getBody().getBlockNum();
    	FileOutputStream fout = null;
    	
    	if ( lastSeq == 0)
    		fout = createFile(false);
    	else
    		fout = createFile(true);
    			
    	if ( fout == null) {
            return false;
        }

    	try {
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int seq_no  = Integer.parseInt(batchDoc.getBatchMsg().getBody().getRecvFld05());

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

        	@SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
    		try {
                String strRecvLen = getJobInfo().getProperty(TelegramKeys.RECV_REC_LEN);
                recLen = Integer.parseInt(strRecvLen);
    		} catch (Exception e) {}

            for (int i = lastSeq + 1; i <= seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                byte[] data = (byte[]) block_data.get(new Integer(i-1));
                
                if ( recLen < 1 ){
                	recLen = data.length;
                }
                byte[]layout = new byte[recLen];
                for (int inx = 0; inx < layout.length; inx++) {
                    layout[inx] = ' ';
                }

                int dataCnt = data.length / recLen ;
                for (int jnx = 0; jnx < dataCnt; jnx++) {
                    System.arraycopy( data,jnx*layout.length,layout,0,layout.length);
                    fout.write(layout);
                    fout.write( '\n' );
                    long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                    batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
                    batchDoc.getBatchMsg().getHeader().setFileSize(lnCurSize);
                    long totRecCnt = batchDoc.getBatchMsg().getHeader().getTotRecCnt();
                    if ( totRecCnt == -1 )
                    	totRecCnt = 0;
                    batchDoc.getBatchMsg().getHeader().setTotRecCnt(++totRecCnt);
                }

            }
            hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 Vector 초기화
            batchDoc.getBatchMsg().getBody().setBlockNum(seq_no);

            return true;

		} catch (Exception e) {
			logger.error( e.getMessage(), e);
			return false;
		}finally{
			try {
				fout.close();
			} catch (Exception e2) {
				logger.error( e2.getMessage(), e2);
			}
		}

    }

    private FileOutputStream createFile (boolean append) {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            File file = new File(strFullPath);
            return new FileOutputStream(file, append);
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return null;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return 84;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            for (int inx = 0; inx < fldLen; inx++) {
				data[inx] = ' ';
			}
            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
}